glibmm: Gio::LoadableIcon Class Reference

glibmm 2.66.6

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::LoadableIcon Class Reference

Extends the Icon interface and adds the ability to load icons from streams. More...

`#include <giomm/loadableicon.h>`

Inheritance diagram for Gio::LoadableIcon:
[legend]

## Public Member Functions
| LoadableIcon (LoadableIcon && src) noexcept
LoadableIcon & | operator= (LoadableIcon && src) noexcept
| ~LoadableIcon () noexcept override
GLoadableIcon * | gobj ()
| Provides access to the underlying C GObject.
const GLoadableIcon * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< InputStream > | load (int size, Glib::ustring & type, const Glib::RefPtr< Cancellable > & cancellable)
| Loads a loadable icon.
Glib::RefPtr< InputStream > | load (int size, Glib::ustring & type)
| Non-cancellable version of load()
void | load_async (int size, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
| Loads an icon asynchronously.
void | load_async (int size, const SlotAsyncReady & slot)
| Non-cancellable version of load_async()
Public Member Functions inherited from Gio::Icon
| Icon (Icon && src) noexcept
Icon & | operator= (Icon && src) noexcept
| ~Icon () noexcept override
GIcon * | gobj ()
| Provides access to the underlying C GObject.
const GIcon * | gobj () const
| Provides access to the underlying C GObject.
guint | hash () const
| Gets a hash for an icon.
std::string | to_string () const
| Generates a textual representation of icon that can be used for serialization such as when passing icon to a different process or saving it to persistent storage.
bool | equal (const Glib::RefPtr< Icon > & other) const
Glib::VariantBase | serialize () const
| Serializes a Icon into a Variant.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::Icon
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< Icon > | create (const std::string & str)
| Generate an Icon instance from str.
static Glib::RefPtr< Icon > | deserialize (const Glib::VariantBase & value)
| Deserializes a Icon previously serialized using g_icon_serialize().

## Protected Member Functions
| LoadableIcon ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gio::Icon
| Icon ()
| You should derive from this class to use it.
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::LoadableIcon > | wrap (GLoadableIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::Icon
Glib::RefPtr< Gio::Icon > | wrap (GIcon * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Extends the Icon interface and adds the ability to load icons from streams.

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ LoadableIcon() [1/2]

Gio::LoadableIcon::LoadableIcon | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ LoadableIcon() [2/2]

Gio::LoadableIcon::LoadableIcon | ( | LoadableIcon && | src | ) |
| noexcept

## ◆ ~LoadableIcon()

Gio::LoadableIcon::~LoadableIcon | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gio::LoadableIcon::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_type()

static GType Gio::LoadableIcon::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GLoadableIcon * Gio::LoadableIcon::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GLoadableIcon * Gio::LoadableIcon::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ load() [1/2]

Glib::RefPtr< InputStream > Gio::LoadableIcon::load | ( | int | size,
|  | Glib::ustring & | type
| ) |  |

Non-cancellable version of load()

## ◆ load() [2/2]

Glib::RefPtr< InputStream > Gio::LoadableIcon::load | ( | int | size,
|  | Glib::ustring & | type,
|  | const Glib::RefPtr< Cancellable > & | cancellable
| ) |  |

Loads a loadable icon.

For the asynchronous version of this function, see load_async().

Parameters

  size | an integer.
  type | a location to store the type of the loaded icon
  cancellable | a Cancellable object

Returns
  a InputStream to read the icon from.

## ◆ load_async() [1/2]

void Gio::LoadableIcon::load_async | ( | int | size,
|  | const SlotAsyncReady & | slot
| ) |  |

Non-cancellable version of load_async()

## ◆ load_async() [2/2]

void Gio::LoadableIcon::load_async | ( | int | size,
|  | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable
| ) |  |

Loads an icon asynchronously.

To finish this function, see load_finish(). For the synchronous, blocking version of this function, see load().

Parameters

  size | an integer.
  cancellable | a Cancellable object
  slot | a function to call when the request is satisfied

## ◆ operator=()

LoadableIcon & Gio::LoadableIcon::operator= | ( | LoadableIcon && | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::LoadableIcon > wrap | ( | GLoadableIcon * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.